package evenements.classes;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.ListSelectionModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;



/**
 * @author jub
 *C'est classe permet de modifier la taille, la police, le style et la couleur d'un label 
 */
public class Polices extends JFrame {
	/**
	 * Le label dont la mise en forme sera modifie
	 */
	private JLabel labelTexte;
	/**
	 * Un liste qui permet de choisir la police du label
	 */
	private JList listPolices;
	/**
	 * Le spinner qui permet de choisir la taille du label
	 */
	private JSpinner spinnerTaille;
	/**
	 * Le colorChooser qui permet de choisir la couleur du label
	 */
	private JColorChooser colorChooser;
	/**
	 * La checkBox qui permet de mettre le label en italic
	 */
	private JCheckBox boxItalic;
	/**
	 * La checkBox qui permet de mettre le label en gras
	 */
	private JCheckBox boxBold;
	
	/**
	 * Permet de constuire la JFrame.
	 * @param titre le titre de la fentre
	 */
	public Polices(String titre)
	{
		super(titre);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLayout(new BorderLayout());
		JPanel panelNord = new JPanel();
		panelNord.setLayout(new BoxLayout(panelNord, BoxLayout.LINE_AXIS));
		panelNord.setPreferredSize(new Dimension(20, 200));
		JPanel panelOuest = new JPanel();
		panelOuest.setLayout(new BoxLayout(panelOuest, BoxLayout.Y_AXIS));
		
		JPanel panelCentre = new JPanel();
		panelCentre.setLayout(new BoxLayout(panelCentre, BoxLayout.Y_AXIS));
		JPanel panelCentreNord = new JPanel();
		JPanel panelCentreSud = new JPanel();
		JPanel panelEst = new JPanel();
		panelEst.setLayout(new BoxLayout(panelEst, BoxLayout.Y_AXIS));
		
		labelTexte=new JLabel("texte");
		panelNord.add(labelTexte);
		
		String[] polices = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		this.listPolices = new JList(polices);
		this.listPolices.setSelectionMode(ListSelectionModel.SINGLE_SELECTION );
		panelOuest.add(new JLabel("Polices"));
		panelOuest.add(new JScrollPane(this.listPolices));
		
		panelCentreNord.add(new JLabel("Taille"));
		spinnerTaille = new JSpinner(new SpinnerNumberModel(labelTexte.getFont().getSize(),4,32,1));
		panelCentreNord.add(spinnerTaille);
		
		colorChooser = new JColorChooser();
		panelCentreSud.add(colorChooser);
		panelCentre.add(panelCentreNord);
		panelCentre.add(panelCentreSud);
		
		panelEst.add(new JLabel("Style"));
		boxItalic = new JCheckBox("Italic");
		boxItalic.setFont(boxItalic.getFont().deriveFont(Font.ITALIC));
		panelEst.add(boxItalic);
		boxBold = new JCheckBox("Bold");
		boxBold.setFont(boxBold.getFont().deriveFont(Font.BOLD));
		panelEst.add(boxBold);
		
		this.add(panelNord, BorderLayout.NORTH);
		this.add(panelOuest, BorderLayout.WEST);
		this.add(panelCentre, BorderLayout.CENTER);
		this.add(panelEst, BorderLayout.EAST);
		
		this.init();
		this.pack();
		this.setVisible(true);
	
		/*
		 * Ajouter ici vos couteurs
		 */
	
		
		
		
		
		/*
		 * Fin de la partie ajout des couteurs
		 */
	
	}
	/* 
	 * Ajouter ici vos classes internes, si vous en avez.
	 */
	
	
	
	
	
	/*
	 * Fin de la partie ajout de vos classes internes si vous en avez.
	 */
	
	/**
	 * Les mthodes de vos classes internes (si vous en avez) appelerons cette mthode.
	 * Elle centralise la mise en forme du label.
	 */
	private void update(){
	
		
		
		
	}
	
	/**
	 * Cette mthode initialise les composant en fonction de la mise en forme du label.
	 * Vous n'avez pas  modifier ou utiliser cette mthode. 
	 */
	private void init(){
		Color color = this.labelTexte.getForeground();
		int size = this.labelTexte.getFont().getSize();
		String police = this.labelTexte.getFont().getName();
		boolean isBold = this.labelTexte.getFont().isBold();
		boolean isItalic = this.labelTexte.getFont().isItalic();
		
		this.colorChooser.setColor(color);
		this.listPolices.setSelectedValue(police, true);
		this.spinnerTaille.setValue(Integer.valueOf(size));
		
		this.boxBold.setSelected(isBold);
		this.boxItalic.setSelected(isItalic);
		
	}
}
